## cxref 1.4

=== Makefile ===
# $Header: /home/amb/cxref/RCS/Makefile 1.34 1997/11/20 19:55:33 amb Exp $
#
# C Cross Referencing & Documentation tool. Version 1.4a.
#
# Program Makefile.
#
# Written by Andrew M. Bishop
#
# This file Copyright 1995,96 Andrew M. Bishop
# It may be distributed under the GNU Public License, version 2, or
# any higher version.  See section COPYING of the GNU Public license
# for conditions under which this file may be redistributed.
#

# Standard definitions, edit Makefile.config not this one.
include ./Makefile.config

########

INCLUDE=
LIBRARY=

COMPILE=$(CC) -c $(CFLAGS)

LINK=$(LD) $(LDFLAGS)

########

programs : cxref-cpp cxref cxref-query
	@

docs : readme faq-html
	cd doc && $(MAKE)

all : programs docs
	@

########

OBJ_FILES=func.o type.o var.o preproc.o comment.o file.o \
          slist.o memory.o \
          xref.o \
          warn-raw.o latex.o latex-style.o \
          html.o \
          parse-lex.o parse-yacc.o

cxref : cxref.o $(OBJ_FILES)
	$(LINK) cxref.o $(OBJ_FILES) -o $@ $(LIBRARY)

cxref-inst : cxref-inst.o $(OBJ_FILES)
	$(LINK) cxref-inst.o $(OBJ_FILES) -o $@ $(LIBRARY)

####

cxref-cpp : cpp/Makefile.cpp
	cd cpp && $(MAKE) cxref-cpp

cpp/Makefile.cpp :
	touch cpp/Makefile.cpp
	cd cpp && $(MAKE) configure

####

cxref-query :
	cd query && $(MAKE) cxref-query

########

faq-html : FAQ FAQ-html.pl
	-[ $(PERL) ] && $(PERL) FAQ-html.pl < FAQ > FAQ.html

####

readme : cxref cxref-cpp README.c
	./cxref -Odoc -NREADME -xref README.c
	./cxref -Odoc -NREADME -xref README.c -html -latex
	cp doc/README.c.html README.c.html
	cp doc/README.c.tex  README_c.tex
	-[ $(LATEX) ] && $(LATEX) README.tex > /dev/null 2>&1
	-[ $(LATEX) ] && $(LATEX) README.tex
	-[ $(DVIPS) ] && $(DVIPS) README.dvi -o README.ps
	@rm -f README.aux README.log README.toc doc/README.*

########

install : programs cxref-inst
	$(INSTALL) -d $(INSTDIR)/bin
	$(INSTALL) -m 755 cxref-inst $(INSTDIR)/bin/cxref
	-@rm cxref-inst
	$(INSTALL) -m 755 query/cxref-query $(INSTDIR)/bin
	[ ! -x cpp/cxref-cpp ] || $(INSTALL) -m 755 cpp/cxref-cpp $(INSTDIR)/bin
	$(INSTALL) -d $(INSTDIR)/man/man1
	$(INSTALL) -m 644 README.man $(INSTDIR)/man/man1/cxref.1
	$(INSTALL) -m 644 query/README.man $(INSTDIR)/man/man1/cxref-query.1
	[ ! -x cpp/cxref-cpp ] || $(INSTALL) -m 644 cpp/README.man $(INSTDIR)/man/man1/cxref-cpp.1

########

clean :
	-rm -f cxref core *.o *~ \
	lex.*.c y.tab.* latex-style.c \
	README.dvi README.ps

####

allclean realclean : clean
	cd doc && $(MAKE) clean
	cd cpp && $(MAKE) clean
	cd query && $(MAKE) clean

########

parse-yacc.c : parse.y
	$(YACC) -d parse.y
	-@mv y.tab.c  parse-yacc.c
	@echo Created parse-yacc.c

parse-yacc.h : parse-yacc.c
	-@if cmp -s parse-yacc.h y.tab.h ; then : ; else \
	   if [ -f y.tab.h ] ; then \
	      cp y.tab.h parse-yacc.h ; \
	      echo Created parse-yacc.h ; \
	   fi \
	fi

####

parse-lex.c : parse.l
	$(LEX) parse.l
	-@mv lex.yy.c parse-lex.c
	@echo Created parse-lex.c

####

latex-style.c : doc/fonts.style doc/page.style doc/cxref.style
	@echo '/** The style files needed for LaTeX. **/' >  latex-style.c
	@echo ''                                          >> latex-style.c
	@echo '/*+ The fonts style file as a string. +*/' >> latex-style.c
	@echo 'char *latex_fonts_style='                  >> latex-style.c
	@sed 's/\\/\\\\/g' doc/fonts.style \
	|awk '{print "\"" $$0 "\\n\""}'                   >> latex-style.c
	@echo ';'                                         >> latex-style.c
	@echo ''                                          >> latex-style.c
	@echo '/*+ The page style file as a string. +*/'  >> latex-style.c
	@echo 'char *latex_page_style='                   >> latex-style.c
	@sed 's/	CONFIG-ONLY PAGE=$(LATEX_PAGE)//g' doc/page.style \
	|grep -v 'CONFIG-ONLY' \
	|sed 's/\\/\\\\/g' \
	|awk '{print "\"" $$0 "\\n\""}'                   >> latex-style.c
	@echo ';'                                         >> latex-style.c
	@echo ''                                          >> latex-style.c
	@echo '/*+ The cxref style file as a string. +*/' >> latex-style.c
	@echo 'char *latex_cxref_style='                  >> latex-style.c
	@sed 's/\\/\\\\/g' doc/cxref.style \
	|awk '{print "\"" $$0 "\\n\""}'                   >> latex-style.c
	@echo ';'                                         >> latex-style.c
	@echo Created latex-style.c

####

%.o:%.c
	$(COMPILE) $< -o $@ $(INCLUDE)

cxref.o      : cxref.c      cxref.h datatype.h   memory.h parse-yy.h
	[ ! -x cpp/cxref-cpp ] || $(COMPILE) cxref.c -o $@ $(INCLUDE) "-DCXREF_CPP=\"$$PWD/cpp/cxref-cpp -C -dD -dI\""
	[   -x cpp/cxref-cpp ] || $(COMPILE) cxref.c -o $@ $(INCLUDE)

cxref-inst.o : cxref.c      cxref.h datatype.h   memory.h parse-yy.h
	[ ! -x cpp/cxref-cpp ] || $(COMPILE) cxref.c -o $@ $(INCLUDE) '-DCXREF_CPP="cxref-cpp -C -dD -dI"'
	[   -x cpp/cxref-cpp ] || $(COMPILE) cxref.c -o $@ $(INCLUDE)

func.o       : func.c       cxref.h datatype.h   memory.h
type.o       : type.c       cxref.h datatype.h   memory.h
var.o        : var.c        cxref.h datatype.h   memory.h
comment.o    : comment.c    cxref.h datatype.h   memory.h
file.o       : file.c       cxref.h datatype.h   memory.h
preproc.o    : preproc.c    cxref.h datatype.h   memory.h

slist.o      : slist.c      cxref.h datatype.h   memory.h
memory.o     : memory.c                          memory.h

xref.o       : xref.c       cxref.h datatype.h   memory.h
warn-raw.o   : warn-raw.c   cxref.h datatype.h   memory.h
latex.o      : latex.c      cxref.h datatype.h   memory.h
latex-style.o: latex-style.c
html.o       : html.c       cxref.h datatype.h   memory.h

parse-yacc.o : parse-yacc.c cxref.h parse-yacc.h memory.h parse-yy.h
parse-lex.o  : parse-lex.c  cxref.h parse-yacc.h memory.h parse-yy.h

########

=== cpp/Makefile ===
# $Header: /home/amb/cxref/cpp/RCS/Makefile 1.11 1997/11/20 19:55:34 amb Exp $
#
# C Cross Referencing & Documentation tool. Version 1.4a.
#
# CPP Makefile.
#
# Written by Andrew M. Bishop
#
# This file Copyright 1995,96 Andrew M. Bishop
# It may be distributed under the GNU Public License, version 2, or
# any higher version.  See section COPYING of the GNU Public license
# for conditions under which this file may be redistributed.
#

# Standard definitions, edit ../Makefile.config not this one.
include ../Makefile.config

# Auto generated Makefile configuration definitions.
include ./Makefile.cpp

########

INCLUDE=
LIBRARY=

COMPILE=$(CC) -c -w $(CFLAGS) -DNEED_SVR4_STRINGS=$(SVR4_STRINGS)

LINK=$(LD) $(LDFLAGS)

########

OBJ_FILES=cccp.o cexp.o version.o

####

cxref-cpp : Makefile.cpp $(OBJ_FILES)
	[ $(CONFIG_STATUS) ] || $(LINK) $(OBJ_FILES) -o $@ $(LIBRARY)
	@touch $@

########

configure Makefile.cpp: config-cpp
	-CC='$(CC)' ./config-cpp

########

clean :
	-rm -f cxref-cpp core *.o *~ y.tab.c Makefile.cpp

########

cexp.c : cexp.y
	[ $(CONFIG_STATUS) ] || $(YACC) cexp.y
	@touch $@
	@mv y.tab.c cexp.c

####

cccp.o: cccp.c config.h tm.h pcp.h
	[ $(CONFIG_STATUS) ] || $(COMPILE) cccp.c -o $@ $(INCLUDE) \
	 '-DLOCAL_INCLUDE_DIR="$(INCLUDE_DIR1)"' \
	 '-DTOOL_INCLUDE_DIR="$(INCLUDE_DIR2)"' \
	 '-DGCC_INCLUDE_DIR="$(INCLUDE_DIR3)"' \
	 '-DGPLUSPLUS_INCLUDE_DIR="."' \
	 '-DCPP_PREDEFINES="$(PREDEFINES)"'
	@touch $@

####

%.o:%.c
	[ $(CONFIG_STATUS) ] || $(COMPILE) $< -o $@ $(INCLUDE)
	@touch $@

version.o    : version.c
cexp.o       : cexp.c config.h tm.h

########

## cxref 1.4-1

=== doc/Makefile ===
# $Header: /home/amb/cxref/doc/RCS/Makefile 1.9 1996/10/29 19:52:36 amb Exp $
#
# C Cross Referencing & Documentation tool. Version 1.3.
#
# Documentation Makefile.
#
# Written by Andrew M. Bishop
#
# This file Copyright 1995,96 Andrew M. Bishop
# It may be distributed under the GNU Public License, version 2, or
# any higher version.  See section COPYING of the GNU Public license
# for conditions under which this file may be redistributed.
#

# Standard definitions, edit ../Makefile.config not this one.
include ../Makefile.config

########

SOURCE_FILES= \
cxref.c       \
cxref.h       \
datatype.h    \
comment.c     \
file.c        \
func.c        \
preproc.c     \
type.c        \
var.c         \
xref.c        \
warn-raw.c    \
latex.c       \
latex-style.c \
html.c        \
slist.c       \
memory.h      \
memory.c      \
parse-yy.h    \
parse-yacc.h  \
parse-lex.c   \
parse-yacc.c 

########

all : sources docs
	@

########

sources :
#
# Create the cross reference files
#
	@for file in $(SOURCE_FILES) ; do \
	   echo Cross referencing $$file ; \
	   ( cd .. ; ./cxref -xref -Odoc -Ncxref $$file ) ; \
	done
#
# Create the source files using cxref
#
	@for file in $(SOURCE_FILES) ; do \
	   echo Documenting $$file ; \
	   ( cd .. ; ./cxref -warn-xref -xref -Odoc -Ncxref -latex -html $$file ) ; \
	done
#
# Create the index using cxref
#
	@echo Indexing
	@( cd .. ; ./cxref -index-all -Odoc -Ncxref -latex -html )

########

docs :
#
# Create the final output using latex
#
	-[ $(LATEX) ] && $(LATEX) cxref.tex > /dev/null 2>&1
#
# Create the cross references using latex
#
	-[ $(LATEX) ] && $(LATEX) cxref.tex

########

clean :
	-rm -f *~ \
	*.sty *.tex *.html \
	cxref.function cxref.include cxref.typedef cxref.variable \
	cxref.aux cxref.dvi cxref.log cxref.toc

########

=== query/Makefile ===
# $Header: /home/amb/cxref/query/RCS/Makefile 1.5 1996/10/29 19:52:59 amb Exp $
#
# C Cross Referencing & Documentation tool. Version 1.3.
#
# Query Program Makefile.
#
# Written by Andrew M. Bishop
#
# This file Copyright 1995,96 Andrew M. Bishop
# It may be distributed under the GNU Public License, version 2, or
# any higher version.  See section COPYING of the GNU Public license
# for conditions under which this file may be redistributed.
#

# Standard definitions, edit ../Makefile.config not this one.
include ../Makefile.config

########

INCLUDE=
LIBRARY=

COMPILE=$(CC) -c $(CFLAGS)

LINK=$(LD) $(LDFLAGS)

########

OBJ_FILES=query.o \
          input.o output.o \
          ../memory.o ../slist.o

####

cxref-query : $(OBJ_FILES)
	$(LINK) $(OBJ_FILES) -o $@ $(LIBRARY)

########

clean :
	-rm -f cxref-query core *.o *~

########

%.o:%.c
	$(COMPILE) $< -o $@ $(INCLUDE)

query.o    : query.c   query.h ../cxref.h ../datatype.h ../memory.h
input.o    : input.c   query.h ../cxref.h ../datatype.h ../memory.h
output.o   : output.c  query.h ../cxref.h ../datatype.h ../memory.h

../memory.o: ../memory.c                                ../memory.h
	$(MAKE) -C .. memory.o

../slist.o : ../slist.c        ../cxref.h ../datatype.h ../memory.h
	$(MAKE) -C .. slist.o

########

=== debian/changelog ===
cxref (1.4-1) unstable; urgency=low

  * Modified latex.c to put table of contents at beginning.
  * Set INSTDIR to 4622(DESTDIR)/usr in Makefile.config
  * Set INSTDIR to /usr in Makefile.config
  * Appended || defined(linux) to line 324 of cccp.c
  * Applied 1.4->1.4a patch script
  * Modified 1.4->1.4a patch script by changing patch -p to patch -p1
  * Initial Release.

 -- Camm Maguire <camm@enhanced.com>  Tue,  9 Dec 1997 19:41:02 -0500

Local variables:
mode: debian-changelog
add-log-mailing-address: "camm@enhanced.com"
End:

=== debian/control ===
Source: cxref
Section: devel
Priority: extra
Suggests: emacs,tetex-bin,tetex-base,tetex-dev
Maintainer: Camm Maguire <camm@enhanced.com>
Standards-Version: 2.3.0.0

Package: cxref
Architecture: any
Depends: ${shlibs:Depends}
Description: Generates latex and HTML documentation for C programs.
 A program that takes as input a series of C source files
 and produces a LaTeX or HTML document containing a cross
 reference of the files/functions/variables in the program,
 including documentation taken from suitably formatted
 source code comments.
 The documentation is stored in the C source file in
 specially formatted comments, making it simple to maintain.
 The cross referencing includes lists of functions called,
 callers of each function, usage of global variables, header
 file inclusion, macro definitions and type definitions.
 Works for ANSI C, including many gcc extensions.

=== debian/rules ===
#!/usr/bin/make -f
# Made with the aid of debmake, by Christoph Lameter,
# based on the sample debian/rules file for GNU hello by Ian Jackson.

package=cxref

build:
	$(checkdir)
	
	make

	touch build

clean:
	$(checkdir)
	-rm -f build
	-make clean
	-make -C query clean
	-make -C cpp clean
	-rm -f `find . -name "*~"`
	-rm -rf debian/tmp `find debian/* -type d ! -name CVS ` debian/files* core
	-rm -f debian/*substvars

binary-indep:	checkroot build
	$(checkdir)
# There are no architecture-independent files to be uploaded
# generated by this package.  If there were any they would be
# made here.

binary-arch:	checkroot build
	$(checkdir)
	-rm -rf debian/tmp `find debian/* -type d`
	install -d debian/tmp
	cd debian/tmp && install -d `cat ../dirs`
	make install DESTDIR=`pwd`/debian/tmp
	debstd ChangeLog NEWS README README.c README.c.html README.html README.man README.tex README_c.tex TODO cxref.el cflow.el
	dpkg-gencontrol -pcxref
	chown -R root.root debian/tmp
	chmod -R go=rX debian/tmp
	dpkg --build debian/tmp ..

define checkdir
	test -f debian/rules
endef

# Below here is fairly generic really

binary:		binary-indep binary-arch

checkroot:
	$(checkdir)
	test root = "`whoami`"

.PHONY: binary binary-arch binary-indep clean checkroot

## cxref 1.6c

=== debian/changelog ===
cxref (1.6c-2) unstable; urgency=low

  * Bug fix: "Opening .c files results in autoload-related error message",
    thanks to Hilko Bengen (Closes: #586219).

 -- Camm Maguire <camm@debian.org>  Thu, 17 Jun 2010 22:23:27 +0000

cxref (1.6c-1) unstable; urgency=low

  * New upstream release

 -- Camm Maguire <camm@debian.org>  Mon, 07 Jun 2010 20:44:58 +0000

cxref (1.6b-1) unstable; urgency=low

  * New upstream release
  * Bug fix: "[INTL:ja] please add Japanese po-debconf template
    translation (ja.po)", thanks to Hideki Yamane \(Debian-JP\) (Closes:
    #557629).
  * Bug fix: "Use autoload, not load", thanks to Trent W\. Buck (Closes:
    #446138).
  * Bug fix: "cxref-cpp-configure output differs by locale", thanks to Lee
    Ayres (Closes: #540908).
  * Bug fix: "FTBFS: Nonexistent build-dependency: tetex-base", thanks to
    Lucas Nussbaum (Closes: #562303).

 -- Camm Maguire <camm@debian.org>  Thu, 07 Jan 2010 16:58:00 +0000

cxref (1.6a-1.2) unstable; urgency=low

  * Non-maintainer upload to fix pending l10n issues.
  * Debconf translations:
    - Galician. Closes: #412871
    - Finnish. Closes: #478568
  * [Lintian] Fix doc-base section to "Programming" in doc-base files
  * [Lintian] Remove non-doc files from listed files in doc-base files
  * [Lintian] Remove extra spaces at the end of cxref.doc-base
  * [Lintian] Add real copyright information to debian/copyright
  * [Lintian] cxref-emacs depend on emacs22 and no longer emacs21
  * [Lintian) No longer ignore errors by "make distclean"

 -- Christian Perrier <bubulle@debian.org>  Fri, 18 Apr 2008 08:47:53 +0200

cxref (1.6a-1.1) unstable; urgency=low

  * Non-maintainer upload (originally meant) to fix longstanding l10n issues
  * Fix FTBFS on Hurd. Thanks to Arnaud Fontaine for the patch
    Closes: #355891
  * Add a build dependency on po-debconf, as it is used in the clean target
  * Debconf translation updates:
    - Swedish added. Closes: #333274
    - Dutch added. Closes: #369001
    - Spanish added. Closes: #334562
    - Vietnamese updated added. Sent during the NMU campaign.
    - Brazilian Portugese added. Sent during the NMU campaign.
    - Russian added. Sent during the NMU campaign.
    - German added. Sent during the NMU campaign.
    - Romanian added. Sent during the NMU campaign.
    - Portuguese added. Sent during the NMU campaign.

 -- Christian Perrier <bubulle@debian.org>  Sat, 28 Oct 2006 18:41:00 +0200

cxref (1.6a-1) unstable; urgency=low

  * New upstream release
  * updated watch file
  * debconf translations added, Closes: #313379.  Closes: #301475.
  * Newer standards

 -- Camm Maguire <camm@enhanced.com>  Fri,  7 Oct 2005 13:47:30 +0000

cxref (1.6-8) unstable; urgency=low

  * Bug fix: ": French debconf templates translation", thanks to
    Christophe Masson (Closes: #300604).  French translations added. 

 -- Camm Maguire <camm@enhanced.com>  Tue, 22 Mar 2005 15:26:35 +0000

cxref (1.6-7) unstable; urgency=high

  * Bug fix: "cxref-doc: error in doc-base file&lt;2&gt;", thanks to Neil
    Woods (Closes: #296688).  Fix doc-base file as suggested.

 -- Camm Maguire <camm@enhanced.com>  Thu, 24 Feb 2005 02:41:01 +0000

cxref (1.6-6) unstable; urgency=high

  * Bug fix: "cxref: broken cxref-cpp wrapper", thanks to Arnaud Giersch
    (Closes: #291314). Apply cxref-cpp.wrap patch.
  * Bug fix: "cxref-doc: error in doc-base file", thanks to Laurent
    Bonnaud (Closes: #285676). flatten cxref-doc/examples/example path
  * Bug fix: "dangling symlink due to splitting of cxref-doc", thanks to
    Ian Zimmerman (Closes: #286410).  Move upper level doc/* files into
    cxref-doc.docs, doc/example/* files into cxref-doc.examples, and only
    TODO and contrib/*el into cxref.docs
  * Bug fix: "cxref: Please switch to gettext-based debconf templates",
    thanks to Martin Quinson (Closes: #283635). Apply 110n patch.
  * Bug fix: "cxref: inappropriate use of debconf", thanks to Steve
    Greenland (Closes: #281991).  Reduce AUTOCONF question priority to
    low.  The AUTOCONF debconf variable is in my mind a warranted use of
    debconf, as setting it implies automatic overwriting of a
    configuration file on dpkg-reconfigure.  In this manner, it is quite
    similar to the xfree use of debconf, where the user is asked if they
    desire manual or automatic configuration file generation.

 -- Camm Maguire <camm@enhanced.com>  Tue, 22 Feb 2005 21:56:10 +0000

cxref (1.6-5) unstable; urgency=high

  * debconf support for automatic cxref-cpp-configure handling, Closes:
    #280927.

 -- Camm Maguire <camm@enhanced.com>  Mon, 15 Nov 2004 19:03:11 +0000

cxref (1.6-4) unstable; urgency=high

  * Apply gcc 3.4 'concat' patch, Closes: #280260

 -- Camm Maguire <camm@enhanced.com>  Mon,  8 Nov 2004 15:19:25 +0000

cxref (1.6-3) unstable; urgency=high

  * Put in missing prototypes in cpp/cccp.c for malloc like functions to
    fix build on amd64 and ia64, where the default return type of int has
    a different size than that of void *.  No gcc warnings as functions
    always invoked with an explicit cast in the code.  Lucked out on alpha
    -- apparently the address ranges allocated happen to fit in 32 bits.
    Closes: #278941.

 -- Camm Maguire <camm@enhanced.com>  Mon,  1 Nov 2004 16:07:54 +0000

cxref (1.6-1) unstable; urgency=high

  * New upstream release
  * Remove extra doc/ directory from examples paths.
  * Upstream cpp now based on gcc/cpp 2.95.  Closes: #250926.
  * _MPIS_SZPTR now defined in /usr/share/cxref/cxref-cpp.defines

 -- Camm Maguire <camm@enhanced.com>  Fri, 29 Oct 2004 15:08:01 +0000

cxref (1.5f-4) unstable; urgency=low

  * Bug fix: "does not search GCC-specific header directory", thanks to
    Matt Kraai (Closes: #260960).  Rebuild against gcc 3.3.4.

 -- Camm Maguire <camm@enhanced.com>  Fri, 23 Jul 2004 19:32:09 +0000

cxref (1.5f-3) unstable; urgency=low

  * Bug fix: "cxref_1.5f-2(mips/unstable): FTBFS: libc6-dev requires gcc's


=== debian/control ===
Source: cxref
Section: devel
Priority: optional
Maintainer: Camm Maguire <camm@debian.org>
Build-Depends: bison (>= 1:1.28-5),debhelper (>= 5 ),flex (>= 2.5.4a-6), linuxdoc-tools, texlive-base-bin, texlive-latex-recommended, debconf, po-debconf
Standards-Version: 3.8.4

Package: cxref
Section: devel
Architecture: any
Depends: ${shlibs:Depends},${misc:Depends},gcc
Suggests: www-browser,texlive-binaries,cxref-doc
Description: Generates LaTeX and HTML documentation for C programs
 A program that takes as input a series of C source files
 and produces a LaTeX or HTML document containing a cross
 reference of the files/functions/variables in the program,
 including documentation taken from suitably formatted
 source code comments.
 The documentation is stored in the C source file in
 specially formatted comments, making it simple to maintain.
 The cross referencing includes lists of functions called,
 callers of each function, usage of global variables, header
 file inclusion, macro definitions and type definitions.
 Works for ANSI C, including many gcc extensions.

Package: cxref-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: www-browser,texlive-binaries
Description: Generates LaTeX and HTML documentation for C programs
 This package provides sample documentation produced by cxref from
 some of the cxref source itself.

Package: cxref-emacs
Section: editors
Architecture: all
Depends: emacs23 | emacsen, emacsen-common (>= 1.4.14),${misc:Depends}
Description: Generates LaTeX and HTML documentation for C programs
 This package provides an emacs mode facilitating the use of cxref,
 and enabling the display of a hierarchical flow graph of cxref
 commented source files.

=== debian/rules ===
#!/usr/bin/make -f
# MAde with the aid of dh_make, by Craig Small
# Sample debian/rules that uses debhelper. GNU copyright 1997 by Joey Hess.
# Some lines taken from debmake, by Cristoph Lameter.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

#export DH_COMPAT=3

build: build-stamp
build-stamp:
	dh_testdir

	CFLAGS="-O2 -fomit-frame-pointer" \
		./configure --prefix=/usr --mandir=/usr/share/man --enable-us-paper \
		--datadir=/etc
	$(MAKE) 

	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp install-stamp

	[ ! -f Makefile ] || $(MAKE) distclean
	-rm -f cxref-inst
	-rm -f *~ \
	README.c.sty README.c.src.html README.c.tex README.c.html README.c.rtf README.c.sgml \
	cxref.function cxref.include cxref.apdx.html cxref.apdx.tex cxref.typedef cxref.variable \
	cxref.aux cxref.dvi cxref.log cxref.toc cxref.html cxref.sty cxref.tex fonts.sty page.sty \
        README_c.tex config.log
	rm -f src/README.man doc/README.dvi
	rm -f cpp/foo.c doc/README.c.html doc/README.c.rtf doc/README.c.sgml doc/README.c.src.html \
		doc/README.ps doc/README_c.tex
	debconf-updatepo
	dh_clean

install: install-stamp
install-stamp: build-stamp
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	rm -f src/README.man
	cp doc/README.man src

	$(MAKE) install DESTDIR=`pwd`/debian/tmp
	$(MAKE) docs DESTDIR=`pwd`/debian/tmp

	mkdir -p debian/tmp/usr/share/emacs/site-lisp/cxref
	cp contrib/*.el debian/tmp/usr/share/emacs/site-lisp/cxref

	mv debian/tmp/usr/bin/cxref-cpp debian/tmp/usr/bin/cxref-cpp.upstream
	cp debian/cxref-cpp.wrap debian/tmp/usr/bin/cxref-cpp
	chmod +x debian/tmp/usr/bin/cxref-cpp

	cp debian/config debian/tmp/etc/cxref
	chmod 644 debian/tmp/etc/cxref/config

	dh_install

	touch install-stamp

# Build architecture-independent files here.
binary-indep: build install
	dh_testdir -i
	dh_testroot -i
	dh_installdocs -i
	dh_installexamples -i -Xdoc/COPYING
	dh_installmenu -i
	dh_installemacsen -i
	dh_installcron -i
	dh_installchangelogs ./ChangeLog -i
	dh_strip -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_shlibdeps -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir -a
	dh_testroot -a
	dh_installdocs -a
	dh_installexamples -a
	dh_installmenu -a
	dh_installemacsen -a
	dh_installcron -a
	dh_installman -p cxref debian/cxref-cc.1
	dh_installchangelogs ./ChangeLog -a
	dh_installdebconf -a
	dh_strip -a
	dh_link -a
	dh_compress -a
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

source diff:                                                                  
	@echo >&2 'source and diff are obsolete - use dpkg-source -b'; false

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary

=== debian/watch ===
# Example watch control file for uscan
# Rename this file to "watch" and then you can run the "uscan" command
# to check for upstream updates and more.
# Site		Directory		Pattern			Version	Script
version=2
opts=pasv http://www.gedanken.demon.co.uk/cxref/ .*cxref-([A-Za-z0-9\.]*)\.tgz	debian	uupdate

## cxref 1.6d

=== debian/changelog ===
cxref (1.6d-6) unstable; urgency=high

  * mode 644 for ucf newfile

 -- Camm Maguire <camm@debian.org>  Wed, 03 Oct 2012 20:39:54 +0000

cxref (1.6d-5) unstable; urgency=high

  * Bug fix: "modifies conffiles (policy 10.7.3): /etc/cxref/config",
    thanks to Andreas Beckmann (Closes: #688562).

 -- Camm Maguire <camm@debian.org>  Wed, 03 Oct 2012 18:05:12 +0000

cxref (1.6d-4) unstable; urgency=high

  * Bug fix: "modifies conffiles (policy 10.7.3): /etc/cxref/config",
    thanks to Andreas Beckmann (Closes: #688562).  Provide default
    cxref-cpp.defines

 -- Camm Maguire <camm@debian.org>  Tue, 02 Oct 2012 16:00:05 +0000

cxref (1.6d-3) unstable; urgency=high

  * Bug fix: "modifies conffiles (policy 10.7.3): /etc/cxref/config",
    thanks to Andreas Beckmann (Closes: #688562).

 -- Camm Maguire <camm@debian.org>  Mon, 01 Oct 2012 17:11:17 +0000

cxref (1.6d-2) unstable; urgency=low

  * Bug fix: "help mode access to source code", thanks to Kevin Ryde
    (Closes: #671581). Symlink elisp source files

 -- Camm Maguire <camm@debian.org>  Sat, 05 May 2012 17:14:47 +0000

cxref (1.6d-1) unstable; urgency=low

  * New upstream release
  * Bug fix: "it] Italian translation of debconf templates", thanks to
    Francesca Ciceri (Closes: #656256).
  * Bug fix: "CPPFLAGS hardening flags missing", thanks to Simon Ruderich
    (Closes: #665202).  Applied CPPFLAGS hardening patch

 -- Camm Maguire <camm@debian.org>  Sat, 07 Apr 2012 12:27:23 +0000

cxref (1.6c-3) unstable; urgency=low

  * Bug fix: "[INTL:da] Danish translation of the debconf templates
    cxref", thanks to Joe Dalton (Closes: #599435).
  * Bug fix: "Please add suport for build-arch and build-indep targets
    plus enable hardening flags", thanks to Niels Thykier (Closes:
    #648879).

 -- Camm Maguire <camm@debian.org>  Thu, 12 Jan 2012 22:04:09 +0000

=== debian/control ===
--- 
+++ 
@@ -2,13 +2,13 @@
 Section: devel
 Priority: optional
 Maintainer: Camm Maguire <camm@debian.org>
-Build-Depends: bison (>= 1:1.28-5),debhelper (>= 5 ),flex (>= 2.5.4a-6), linuxdoc-tools, texlive-base-bin, texlive-latex-recommended, debconf, po-debconf
-Standards-Version: 3.8.4
+Build-Depends: bison (>= 1:1.28-5),debhelper (>= 5 ),flex (>= 2.5.4a-6), linuxdoc-tools, texlive-base-bin, texlive-latex-recommended, debconf, po-debconf, dpkg-dev (>= 1.16.1~)
+Standards-Version: 3.9.3
 
 Package: cxref
 Section: devel
 Architecture: any
-Depends: ${shlibs:Depends},${misc:Depends},gcc
+Depends: ${shlibs:Depends},${misc:Depends},gcc,ucf
 Suggests: www-browser,texlive-binaries,cxref-doc
 Description: Generates LaTeX and HTML documentation for C programs
  A program that takes as input a series of C source files

=== debian/rules ===
--- 
+++ 
@@ -8,12 +8,17 @@
 
 #export DH_COMPAT=3
 
-build: build-stamp
+DPKG_EXPORT_BUILDFLAGS=1
+
+include /usr/share/dpkg/buildflags.mk
+
+build: build-arch build-indep
+build-arch: build-stamp
+build-indep: build-stamp
 build-stamp:
 	dh_testdir
 
-	CFLAGS="-O2 -fomit-frame-pointer" \
-		./configure --prefix=/usr --mandir=/usr/share/man --enable-us-paper \
+	./configure --prefix=/usr --mandir=/usr/share/man --enable-us-paper \
 		--datadir=/etc
 	$(MAKE) 
 
@@ -57,8 +62,9 @@
 	cp debian/cxref-cpp.wrap debian/tmp/usr/bin/cxref-cpp
 	chmod +x debian/tmp/usr/bin/cxref-cpp
 
-	cp debian/config debian/tmp/etc/cxref
-	chmod 644 debian/tmp/etc/cxref/config
+#	mkdir -p debian/tmp/etc/cxref
+#	cp debian/config debian/tmp/etc/cxref
+#	chmod 644 debian/tmp/etc/cxref/config
 
 	dh_install
 
@@ -109,4 +115,5 @@
 	@echo >&2 'source and diff are obsolete - use dpkg-source -b'; false
 
 binary: binary-indep binary-arch
-.PHONY: build clean binary-indep binary-arch binary
+.PHONY: build build-arch build-indep clean binary-indep binary-arch binary
+

=== debian/watch ===
# Example watch control file for uscan
# Rename this file to "watch" and then you can run the "uscan" command
# to check for upstream updates and more.
# Site		Directory		Pattern			Version	Script
version=2
opts=pasv http://www.gedanken.demon.co.uk/download-cxref/ .*cxref-([A-Za-z0-9\.]*)\.tgz	debian	uupdate

## cxref 1.6e

=== debian/changelog ===
cxref (1.6e-9) unstable; urgency=medium

  * replace supplement files wit explicit work arounds for known header
    file issues in cpp/cxref-cpp-configure.in

 -- Camm Maguire <camm@debian.org>  Tue, 07 May 2024 09:17:35 -0400

cxref (1.6e-8) unstable; urgency=medium

  * correct supplement defines files naming

 -- Camm Maguire <camm@debian.org>  Tue, 07 May 2024 06:46:23 -0400

cxref (1.6e-7) unstable; urgency=medium

  * amd64, i386,ppc64el,hurd-i386,hurd-amd64
    cxref-cpp-supplemental.defines files

 -- Camm Maguire <camm@debian.org>  Mon, 06 May 2024 20:43:14 -0400

cxref (1.6e-6) unstable; urgency=medium

  * Bug fix: "arm64 FTBFS with glibc 2.38", thanks to Graham Inggs
    (Closes: #1070444).
  * Bug fix: "no output -- tmpfile is depreced", thanks to Martin Kovarik
    (Closes: #979632).

 -- Camm Maguire <camm@debian.org>  Mon, 06 May 2024 12:49:07 -0400

cxref (1.6e-5) unstable; urgency=medium

  * Bug fix: "please make the build reproducible - non-reproducible
    timestamp in build log", thanks to Philip Rinn (Closes: #1014877).
    rm cxref.log from cxref-doc package.
  * Bug fix: "please rebuild with dh_elpa 2.x", thanks to David Bremner
    (Closes: #973966).  Remove build-dep on dh-elpa for now.
  * Bug fix: "cxref FTCBFS: uses AC_TRY_COMPILE", thanks to Helmut Grohne
    (Closes: #962163).  Apply AC_TRY_COMPILE patch
  * tempfile -> mktemp in cxref-cpp-wrap
 
 -- Camm Maguire <camm@debian.org>  Fri, 15 Jul 2022 10:34:54 -0400

cxref (1.6e-4) unstable; urgency=medium

  * Acknowledge NMU with modifications, thanks Philip Rinn
    <rinni@inventati.org>!
  * export GREP and EGREP before configure in rules
  * export FORCE_SOURCE_DATE=1 in rules for texlive reproducibility
  * export LC_ALL=C.UTF-8 in rules for locale reproducibility
  * Remove build path from documentation in rules
  * Build-dep debhelper-compat (= 13)
  * watch version 4
  * utf-8 for cs.po, fr.po, and sv.po
  * /usr/share/doc/cxref/ in cxref-doc.doc-base

 -- Camm Maguire <camm@debian.org>  Tue, 12 Jul 2022 13:03:49 -0400

cxref (1.6e-3.2) unstable; urgency=medium

  * Non-maintainer upload by the Reproducible Builds team.
  * Fix reproducibility issues (Closes: #995886, #995896, #995953, #995954)

 -- Philip Rinn <rinni@inventati.org>  Mon, 04 Jul 2022 18:08:52 +0200

cxref (1.6e-3.1) unstable; urgency=medium

  * Non maintainer upload by the Reproducible Builds team.
  * No source change upload to rebuild on buildd with .buildinfo files.

 -- Holger Levsen <holger@debian.org>  Sun, 03 Jan 2021 17:31:29 +0100

cxref (1.6e-3) unstable; urgency=high

  * Bug fix: "cxref FTBFS on amd64/i386 with glibc 2.26", thanks to Adrian
    Bunk (Closes: #887866). Added defined to doc/Makefile.in, no doubt a
    better way.
  * Added homepage entry to control
  * Bug fix: "please add Homepage field", thanks to Juhani Numminen
    (Closes: #888483).
  * Bug fix: "Duplicate and conflicting definition of function
    check_assertion", thanks to Michael Tautschnig (Closes: #748116).
    Fixed in 1.6e upstream.
  * Bug fix: "maintainer script(s) do not start on #!", thanks to
    treinen@debian.org</a>; (Closes: #843271).
  * Bug fix: "maintainer script(s) not using strict mode", thanks to
    treinen@debian.org</a>; (Closes: #866264).
  * compat level 9
  * dh_prep
  * c warning cleanups

 -- Camm Maguire <camm@debian.org>  Tue, 30 Jan 2018 16:50:37 +0000

cxref (1.6e-2) unstable; urgency=high

  * Bug fix: "cxref complains about a locally modified config file on a
    fresh installation", thanks to Uwe Storbeck (Closes: #795098).
  * added emacs add-on compat file to cxref-emacs
  * latest standards

 -- Camm Maguire <camm@debian.org>  Sat, 05 Sep 2015 13:21:22 +0000

cxref (1.6e-1) unstable; urgency=high

  * New upstream release
  * Bug fix: "please switch to emacs24", thanks to Gabriele Giacone
    (Closes: #753998).
  * Bug fix: "cxref dumps core with function def with function pointer",
    thanks to John Vogel (Closes: #667443).  Applied FAQ patch.
  * updated watch file
  * Bug fix: "[Mayhem] Bug report on cxref: cxref crashes with exit status
    139", thanks to Alexandre Rebert (Closes: #715771).

 -- Camm Maguire <camm@debian.org>  Tue, 09 Sep 2014 14:14:05 -0400

=== debian/rules ===
--- 
+++ 
@@ -8,9 +8,23 @@
 
 #export DH_COMPAT=3
 
+include /usr/share/dpkg/pkg-info.mk
+export DEB_VERSION_UPSTREAM
+export DEB_UPSTREAM_VERSION
+
+VERS:=$(shell cat debian/changelog |grep ^cxref|head -n 1|cut -f2 -d\ |tr -d '()[a-z]')
+
 DPKG_EXPORT_BUILDFLAGS=1
 
+# Ensure texlive respects SOURCE_DATE_EPOCH
+export FORCE_SOURCE_DATE=1
+
+# Force locale to avoid differences when building with obscure locales
+export LC_ALL=C.UTF-8
+
 include /usr/share/dpkg/buildflags.mk
+
+DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
 
 build: build-arch build-indep
 build-arch: build-stamp
@@ -18,6 +32,8 @@
 build-stamp:
 	dh_testdir
 
+#	For (non-)usrmerge build reproducibility
+	GREP="/bin/grep" EGREP="$GREP -E" \
 	./configure --prefix=/usr --mandir=/usr/share/man --enable-us-paper \
 		--datadir=/etc
 	$(MAKE) 
@@ -36,7 +52,7 @@
 	cxref.function cxref.include cxref.apdx.html cxref.apdx.tex cxref.typedef cxref.variable \
 	cxref.aux cxref.dvi cxref.log cxref.toc cxref.html cxref.sty cxref.tex fonts.sty page.sty \
         README_c.tex config.log
-	rm -f src/README.man doc/README.dvi
+	rm -f src/README.man doc/README.dvi doc/FAQ.html
 	rm -f cpp/foo.c doc/README.c.html doc/README.c.rtf doc/README.c.sgml doc/README.c.src.html \
 		doc/README.ps doc/README_c.tex
 	debconf-updatepo
@@ -46,7 +62,7 @@
 install-stamp: build-stamp
 	dh_testdir
 	dh_testroot
-	dh_clean -k
+	dh_prep
 	dh_installdirs
 
 	rm -f src/README.man
@@ -55,12 +71,28 @@
 	$(MAKE) install DESTDIR=`pwd`/debian/tmp
 	$(MAKE) docs DESTDIR=`pwd`/debian/tmp
 
+#	Remove log file (contains non-reproducible timestamp) 
+	rm -f doc/example/cxref.log
+
+# 	Remove build path from documentation
+	find doc/ -type f -exec sed -i -e "s,$(CURDIR),BUILDPATH,g" '{}' \;
+
+	mkdir -p debian/tmp/usr/share/cxref
+	mv debian/tmp/etc/cxref/cxref-cpp.defines debian/tmp/usr/share/cxref
+
 	mkdir -p debian/tmp/usr/share/emacs/site-lisp/cxref
 	cp contrib/*.el debian/tmp/usr/share/emacs/site-lisp/cxref
 
 	mv debian/tmp/usr/bin/cxref-cpp debian/tmp/usr/bin/cxref-cpp.upstream
 	cp debian/cxref-cpp.wrap debian/tmp/usr/bin/cxref-cpp
 	chmod +x debian/tmp/usr/bin/cxref-cpp
+
+	mkdir -p debian/tmp/usr/lib/emacsen-common/packages/compat
+	echo 0 >debian/tmp/usr/lib/emacsen-common/packages/compat/cxref-emacs
+
+#	cat debian/cxref-emacs-pkg.el.in |
+#		sed "s,@VERS@,$(VERS),1" >
+#		debian/tmp/usr/share/emacs/site-lisp/cxref/cxref-emacs-pkg.el
 
 #	mkdir -p debian/tmp/etc/cxref
 #	cp debian/config debian/tmp/etc/cxref
@@ -78,6 +110,7 @@
 	dh_installexamples -i -Xdoc/COPYING
 	dh_installmenu -i
 	dh_installemacsen -i
+#	dh_elpa -i -v
 	dh_installcron -i
 	dh_installchangelogs ./ChangeLog -i
 	dh_strip -i
@@ -97,6 +130,7 @@
 	dh_installexamples -a
 	dh_installmenu -a
 	dh_installemacsen -a
+#	dh_elpa -a
 	dh_installcron -a
 	dh_installman -p cxref debian/cxref-cc.1
 	dh_installchangelogs ./ChangeLog -a

=== debian/watch ===
# Example watch control file for uscan
# Rename this file to "watch" and then you can run the "uscan" command
# to check for upstream updates and more.
# Site		Directory		Pattern			Version	Script
version=4
opts=pasv http://www.gedanken.org.uk/software/cxref/download/ .*cxref-([A-Za-z0-9\.]*)\.tgz	debian	uupdate
